// Globals
variable "project_name" {
    description = "Project name for everything"
    type = string
}

variable "username" {
    description = "Openstack username"
    type = string
}

variable "password" {
    description = "Openstack password"
    type = string
}

variable "auth_url" {
    description = "Openstack authentication url"
    type = string
}

variable "competition_domain" {
    description = "Domain for the competition"
    type = string
}

variable "competition_name" {
    description = "The name of the competition e.g. ISTS"
    type = string
}

// tags
variable "inherited_tags" {
    description = "Tags for Instances"
    type = set(string)
}

// ddclient vars
variable "vpn_ddclient_vars" {
    description = "Username, password, fqdn for vpn ddclient"
    type = map
    default = {"username" = "", "password" = "", "dnsname" = ""}
}

variable "scoring_ddclient_vars" {
    description = "Username, password, fqdn for scoring ddclient"
    type = map
    default = {"username" = "", "password" = "", "dnsname" = ""}
}

variable "deploy_ddclient_vars" {
    description = "Username, password, fqdn for deploy ddclient"
    type = map
    default = {"username" = "", "password" = "", "dnsname" = ""}
}

variable "beat_ddclient_vars" {
    description = "Username, password, fqdn for beat ddclient"
    type = map
    default = {"username" = "", "password" = "", "dnsname" = ""}
}

variable "store_ddclient_vars" {
    description = "Username, password, fqdn for store ddclient"
    type = map
    default = {"username" = "", "password" = "", "dnsname" = ""}
}

variable "ctf_ddclient_vars" {
    description = "Username, password, fqdn for ctf ddclient"
    type = map
    default = {"username" = "", "password" = "", "dnsname" = ""}
}

