// Add competition group to each project so that things can be read from and written to
data "openstack_identity_group_v3" "competition_management_group" {
    name = "competition-management"
}

data "openstack_identity_group_v3" "blackteam_group" {
    name = "blackteam"
}

data "openstack_identity_role_v3" "admin_role" {
    name = "admin"
}

data "openstack_identity_role_v3" "member_role" {
    name = "member"
}

data "openstack_identity_role_v3" "viewer_role" {
    name = "reader"
}

locals {
    groups_roles = {
        (data.openstack_identity_group_v3.competition_management_group.id): data.openstack_identity_role_v3.admin_role.id
        (data.openstack_identity_group_v3.blackteam_group.id): data.openstack_identity_role_v3.member_role.id
    }
}

// Add project management group to management project as admins
resource "openstack_identity_role_assignment_v3" "admin_group_management_assignment" {
    for_each = local.groups_roles
    group_id = each.key
    role_id = each.value
    project_id = openstack_identity_project_v3.management_project.id
}
