// Management Secgroups
resource "openstack_networking_secgroup_v2" "koth_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} KotH Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "koth_secgroup_rule" {
    direction = "ingress"
    ethertype = "IPv4"
    security_group_id = openstack_networking_secgroup_v2.koth_secgroup.id
}

resource "openstack_networking_secgroup_v2" "beat_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Beat Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "beat_secgroup_rule" {
    for_each = var.beat_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.beat_secgroup.id
}

resource "openstack_networking_secgroup_v2" "store_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Store Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "store_secgroup_rule" {
    for_each = var.store_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.store_secgroup.id
}

resource "openstack_networking_secgroup_v2" "phone_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Phone Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "phone_secgroup_rule" {
    for_each = var.phone_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.phone_secgroup.id
}

resource "openstack_networking_secgroup_v2" "choco_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Choco Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "choco_secgroup_rule" {
    for_each = var.choco_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.choco_secgroup.id
}

resource "openstack_networking_secgroup_v2" "ctf_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} CTF Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "ctf_secgroup_rule" {
    for_each = var.ctf_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.ctf_secgroup.id
}

resource "openstack_networking_secgroup_v2" "deploy_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Deploy Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "deploy_secgroup_rule" {
    for_each = var.deploy_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.deploy_secgroup.id
}

resource "openstack_networking_secgroup_v2" "dns_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} DNS Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "dns_secgroup_rule" {
    for_each = var.dns_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = each.value == 53 ? "udp" : "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.dns_secgroup.id
}

resource "openstack_networking_secgroup_v2" "game_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Game Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "game_secgroup_rule" {
    for_each = var.game_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.game_secgroup.id
}

resource "openstack_networking_secgroup_v2" "scorestack_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Scorestack Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "scorestack_secgroup_rule" {
    for_each = var.scorestack_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.scorestack_secgroup.id
}

resource "openstack_networking_secgroup_v2" "vpn_internal_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} VPN Internal Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "vpn_internal_secgroup_rule" {
    direction = "ingress"
    ethertype = "IPv4"
    security_group_id = openstack_networking_secgroup_v2.vpn_internal_secgroup.id
}

resource "openstack_networking_secgroup_v2" "vpn_external_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} VPN External Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "vpn_external_secgroup_tcp_rule" {
    for_each = var.vpn_external_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.vpn_external_secgroup.id
}

resource "openstack_networking_secgroup_rule_v2" "vpn_external_secgroup_udp_rule" {
    for_each = var.vpn_external_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "udp"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.vpn_external_secgroup.id
}

// Logging Security Groups
resource "openstack_networking_secgroup_v2" "logging_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Logging Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "allow_lan_traffic" {
    for_each = var.logging_data_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    remote_ip_prefix = "10.0.0.0/8"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.logging_secgroup.id
}

resource "openstack_networking_secgroup_rule_v2" "allow_cloud_traffic" {
    for_each = var.logging_data_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    remote_ip_prefix = "172.16.0.0/16"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.logging_secgroup.id
}

resource "openstack_networking_secgroup_rule_v2" "allow_access_to_logs" {
    for_each = var.logging_access_ports
    description = each.key
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "tcp"
    remote_ip_prefix = "0.0.0.0"
    port_range_min = each.value
    port_range_max = each.value
    security_group_id = openstack_networking_secgroup_v2.logging_secgroup.id
}

resource "openstack_networking_secgroup_v2" "null_secgroup" {
    tenant_id = openstack_identity_project_v3.management_project.id
    name = "${var.competition_name} Null Secgroup"
    description = "This exists because null is not a valid option for a list of secgroup names in terraform"
}

// Add ICMP rule
locals {
    secgroups = {
        "beat": openstack_networking_secgroup_v2.beat_secgroup.id
        "choco": openstack_networking_secgroup_v2.choco_secgroup.id
        "ctf": openstack_networking_secgroup_v2.ctf_secgroup.id
        "dns": openstack_networking_secgroup_v2.dns_secgroup.id
        "game": openstack_networking_secgroup_v2.game_secgroup.id
        "scorestack": openstack_networking_secgroup_v2.scorestack_secgroup.id
        "vpn_internal": openstack_networking_secgroup_v2.vpn_internal_secgroup.id
        "vpn_external": openstack_networking_secgroup_v2.vpn_external_secgroup.id
        "null": openstack_networking_secgroup_v2.null_secgroup.id
        "deploy": openstack_networking_secgroup_v2.deploy_secgroup.id
        "logging": openstack_networking_secgroup_v2.logging_secgroup.id
    }
}

resource "openstack_networking_secgroup_rule_v2" "icmp_rule" {
    for_each = local.secgroups
    description = "icmp"
    direction = "ingress"
    ethertype = "IPv4"
    protocol = "icmp"
    security_group_id = each.value
}