// Global Variable
variable "username" {
    description = "Openstack username"
    type = string
}

variable "password" {
    description = "Openstack password"
    type = string
}

variable "auth_url" {
    description = "Openstack authentication url"
    type = string
}

//Competition Specific Variables
variable "project_name" {
    description = "Project name for everything"
    type = string
}

variable "competition_name" {
    description = "The name of the competition e.g. ISTS"
    type = string
}

variable "competition_domain" {
    description = "Domain for the competition"
    type = string
}

variable "num_teams" {
    description = "Number of teams to provisions"
    type = number
    default = 0
}


// Security Group Ports
variable "beat_ports" {
    description = "Allowed ports to dynamicbeat instance (empty for all)"
    type = map
    default = {"ssh": 22}
}

variable "choco_ports" {
    description = "Allowed ports to chocolately server (empty for all)"
    type = map
    default = {"choco": 80, "winrm": 5986}
}

variable "ctf_ports" {
    description = "Allowed ports to CTF host (empty for all)"
    type = map
    default = {"http": 80, "https": 443, "ssh": 22}
}

variable "deploy_ports" {
    description = "Allowed ports to deployment host (empty for all)"
    type = map
    default = {"ssh": 22}
}

variable "dns_ports" {
    description = "Allowed ports to dns host (empty for all)"
    type = map
    default = {"dns": 53, "winrm": 5986}
}

variable "game_ports" {
    description = "Allowed ports to game host (empty for all)"
    type = map
    default = {"http": 80, "https": 443, "ssh": 22}
}

variable "store_ports" {
    description = "Allowed ports to store host (empty for all)"
    type = map
    default = {"http": 80, "https": 443, "ssh": 22}
}

variable "phone_ports" {
    description = "Allowed ports to store host (empty for all)"
    type = map
    default = {"http": 80, "https": 443, "ssh": 22}
}

variable "scorestack_ports" {
    description = "Allowed ports to scorestack host (empty for all)"
    type = map
    default = {"http": 80, "https": 443, "logstash": 5454, "elasticsearch": 9200, "transport": 9300, "kibana": 5601, "ssh": 22}
}

variable "vpn_external_ports" {
    description = "Allowed ports to vpn host from internet (empty for all)"
    type = map
    default = {"vpn": 1194, "ssh": 22}
}

variable "logging_data_ports" {
    description = "Allowed ports for sending data to logging host (empty for all)"
    type = map
    default = {"logstash": 5454, "elasticsearch": 9200, "transport": 9300}
}

variable "logging_access_ports" {
    description = "Allowed ports for accessing logging host (empty for all)"
    type = map
    default = {"http": 80, "https": 443, "kibana": 5601, "ssh": 22}
}

variable "logging_team_ports" {
    description = "Allowed ports for team logging hosts (empty for all)"
    type = map
    default = {"kibana": 5601, "ssh": 22, "beat": 5044}
}