// Team Cloud Security Group
resource "openstack_networking_secgroup_v2" "cloud_secgroup" {
    tenant_id = openstack_identity_project_v3.cloud_project.id
    name = "${var.competition_name} Cloud Secgroup"
}

resource "openstack_networking_secgroup_rule_v2" "cloud_secgroup_rule" {
    direction = "ingress"
    ethertype = "IPv4"
    security_group_id = openstack_networking_secgroup_v2.cloud_secgroup.id
}

// Team LAN Security Groups
resource "openstack_networking_secgroup_v2" "team_secgroup" {
    count = var.num_teams
    tenant_id = openstack_identity_project_v3.team_project[count.index].id
    name = format("%s Team %02d Secgroup", var.competition_name, count.index + 1)
}

resource "openstack_networking_secgroup_rule_v2" "team_secgroup_rule" {
    count = var.num_teams
    direction = "ingress"
    ethertype = "IPv4"
    security_group_id = openstack_networking_secgroup_v2.team_secgroup[count.index].id
}

// Team LAN Security Groups
resource "openstack_networking_secgroup_v2" "auxilia_secgroup" {
    count = var.num_teams
    tenant_id = openstack_identity_project_v3.team_project[count.index].id
    name = format("%s Team %02d Auxilia Secgroup", var.competition_name, count.index + 1)
}

resource "openstack_networking_secgroup_rule_v2" "auxilia_secgroup_rule" {
    count = var.num_teams
    direction = "ingress"
    ethertype = "IPv4"
    security_group_id = openstack_networking_secgroup_v2.auxilia_secgroup[count.index].id
}