# Teams Terraform

The teams directory for terraform for ISTS 2022

## Usage
To use this terraform, first create the terraform workspaces. `for i in {XX..YY}; do terraform workspace new team$i; done`

Then, run terraform init, within each workspace. `for i in {XX..YY}; do terraform workspace select team$i; terraform init; done`

Finally, apply the terraform changes to the infrastructure. `for i in {XX..YY}; do terraform workspace select team$i; terraform apply -var team_num=$i -auto-approve; done`

You may need to use the `username`, and `password` variables in the bash one liners if a `secrets.auto.tfvars` file does not exist. EX: `for i in {01..02}; do terraform workspace select team$i; terraform destroy -var password=$PW -var user_name=$UN -var team_num=$i -auto-approve; done `

## Destroying Resources
In case you need to destroy a team, use this command:
`for i in {XX..XX}; do terraform workpsace select team$i; terraform destroy -var team_num=$i -auto-approve; done`

If you want to destroy a single host:
`terraform destroy -target='module.<MODULE_NAME>.openstack_compute_instance_v2.<INSTANCE_CLASS>["HOSTNAME"]'`

Run `terraform show | grep <HOSTNAME>` and copy the format from the output to fill in the details.